/* Sistemas Integrados TECNISA

Nome: 0212_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   26/02/2004 - Jenilson
*/


/* Tabela ESTOSEGU: Estoque de Segurana
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ESTOSEGU*/
/* Objetivo:  Gerar um log que vai registrar as alteraes na tabela Estoque de Segurana,
              utilizando a tabela Geral de Logs de Operaes*/
CREATE OR REPLACE TRIGGER LOG_SUP_ESTOSEGU
AFTER DELETE OR INSERT OR UPDATE
ON ESTOSEGU FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC       := 'Filial '          || '' || :NEW.CDFILIAL    || ' ' ||
                      'Produto '         || '' || :NEW.CDPRODESTO  || ' ' ||
                      'Qtde. Est. Seg. ' || '' || :NEW.QTESTOSEGU;
      V_ITPESQ     := :NEW.CDFILIAL||:NEW.CDPRODESTO;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
         V_DESC       := 'Filial '          || '' || :NEW.CDFILIAL    || ' ' ||
                         'Produto '         || '' || :NEW.CDPRODESTO  || ' ' ||
                         'Qtde. Est. Seg. ' || '' || :NEW.QTESTOSEGU;
         V_ITPESQ     := :NEW.CDFILIAL||:NEW.CDPRODESTO;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING  THEN
            V_DESC       := 'Filial '          || '' || :OLD.CDFILIAL    || ' ' ||
                            'Produto '         || '' || :OLD.CDPRODESTO  || ' ' ||
                            'Qtde. Est. Seg. ' || '' || :OLD.QTESTOSEGU;
            V_ITPESQ     := :OLD.CDFILIAL||:OLD.CDPRODESTO;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
    VALUES
      ('ESTOSEGU',
       SYSDATE,
       NVL(V_NMOPERADOR, ' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/
